
__kernel void crossover(__constant uint* first,
						__constant uint* second,
						__global uint* chromosomes,
						__global uint* R,
						__constant uint* dimension)
{
    int gid = get_global_id(0);
    int id = gid % dimension[0];
	chromosomes[gid] = (first[id] & second[id]) | (R[gid] & (first[id] ^ second[id]));
}

__kernel void calculateFloats(__global uint* chromosomes,
							  __global float* memory,
							  __constant float* min,
							  __constant float* max,
							  __constant float* max_int_value)
{
	int gid = get_global_id(0);
	memory[gid] = ((convert_float(chromosomes[gid])) / *max_int_value) * (*max-*min) + *min;
}

__kernel void mutation(__global uint* C, __global uint* M)
{
	int gid = get_global_id(0);
	C[gid] ^= M[gid];
}