#include "declarations.h"
#include "helperFunctions.h"


float rastrigin(float *x, unsigned dimension)
{
	float result = 10 * dimension;
	for (unsigned i = 0; i < dimension; i++)
	{
		result += (x[i]*x[i] - 10 * cos(2 * PI * x[i]));
	}
	return result;
}


void chromosomeToFloats(unsigned *chromosome, float *memory, unsigned dimension, float min, float max, float max_int_value)
{
	for (unsigned int i = 0; i < dimension; i++)
	{
		memory[i] = ((float)chromosome[i]/max_int_value)*(max-min) + min;
	}
}

void displayDataFloat(float *memory, unsigned number, unsigned dimension)
{
	for (unsigned i = 0; i < number; i++)
	{
		for (unsigned j = 0; j < dimension; j++)
		{
			printf("%f ", memory[i * dimension + j]);
		}
		printf("\n");		
	}
}
void displayDataUnsigned(unsigned *memory, unsigned number, unsigned dimension)
{
	for (unsigned i = 0; i < number; i++)
	{
		for (unsigned j = 0; j < dimension; j++)
		{
			printf("%d ", memory[i * dimension + j]);
		}
		printf("\n");		
	}
}


void dataCopy(unsigned *source, unsigned *destination, unsigned dimension)
{
	for (unsigned i = 0; i < dimension; i++)
	{
		destination[i] = source[i];
	}
}
bool selection(float *fitnessValues, unsigned *chromosomes, unsigned *firstParent, unsigned *secondParent, float *first, float *second, unsigned population_size, unsigned dimension)
{
	bool changed = false;
	int indexFirst = -1,indexSecond = -1;
	for (unsigned i = 0; i < population_size; i++)
	{
		if (fitnessValues[i] < *first) 
		{
			indexFirst = i;
			*first = fitnessValues[i];
		}
	}
	for (unsigned i = 0; i < population_size; i++)
	{
		if ((fitnessValues[i] < *second) && (indexFirst != i))
		{
			indexSecond = i;
			*second = fitnessValues[i];
		}
	}
	if (indexFirst > 0) 
	{
		dataCopy(&chromosomes[indexFirst * dimension], &firstParent[0], dimension);
		changed = true;
	}
	if (indexSecond > 0) 
	{
		dataCopy(&chromosomes[indexSecond * dimension], &secondParent[0], dimension);
		changed = true;
	}
	return changed;
}
void crossover(unsigned *parOne, unsigned *parTwo, unsigned *child, unsigned *random_values, unsigned dimension)
{
	for (unsigned i = 0; i < dimension; i++)
	{
		child[i] = (parOne[i] & parTwo[i]) | (random_values[i] & (parOne[i] ^ parTwo[i]));
	}
}


