#include "mpiUtils.h"

void AcceptChromosome(unsigned *chromosome, unsigned dimension, int source, int tag)
{
	MPI_Status status;
	MPI_Recv(&chromosome[0], dimension, MPI_UNSIGNED, source, tag, MPI_COMM_WORLD, &status);
}

void SendChromosome(unsigned *chromosome, unsigned dimension, int destination, int tag)
{
	MPI_Request request;
	MPI_Isend(&chromosome[0], dimension, MPI_UNSIGNED, destination, tag, MPI_COMM_WORLD, &request );
}

bool RecievedMessage(int source, int tag)
{
	int flag;
	MPI_Status status;
	MPI_Iprobe(source, tag, MPI_COMM_WORLD, &flag, &status);
	if (flag) return true;
	else return false;
}

void SendRequest(int destination, int tag, float *bestValue)
{
	MPI_Request request;
	MPI_Isend(bestValue, 1, MPI_FLOAT, destination, tag, MPI_COMM_WORLD, &request);
}
float AcceptRequest(int source, int tag)
{
	MPI_Status status;
	float result;
	MPI_Recv(&result, 1, MPI_FLOAT, source, tag, MPI_COMM_WORLD, &status);
	return result;
}